﻿Type=StaticCode
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Public NutzerDatenbank As KeyValueStore
	Private bc As ByteConverter
End Sub

Public Sub init
	NutzerDatenbank.Initialize(File.DirApp, "NutzerDatenbank")
End Sub


Public Sub CheckUserExist (name As String) As Boolean
	Return NutzerDatenbank.ContainsKey(name)
End Sub

Public Sub DeleteUser (name As String) As Boolean
	Try
		NutzerDatenbank.Remove(name)
		Return True
	Catch
		Return False
	End Try
End Sub

Public Sub CheckCredentials(User As String, Password As String, acode As String) As String

	Dim Credentials As List
	Credentials=NutzerDatenbank.GetEncrypted(User, Main.SchluesselBenutzerDatenbank)
	
	Dim Ergebnis As String="Zugriff mit falschen Absendernamen oder Passwort erfolgt!"
	
	If Credentials.IsInitialized Then
		
		Dim saltstring As String = Credentials.Get(1)
		Dim hash As String = CalcHash(Password, saltstring.GetBytes("ISO-8859-1"))
		Dim storedHash As String = Credentials.Get(0)
		
		If hash <> storedHash Then
			Ergebnis="Zugriff mit falschen Absendernamen oder Passwort erfolgt!"
		Else
			If Credentials.Get(2)<>"aktiv" Then 	
				If acode<>"" Then 
					If Credentials.Get(2)<>acode Then
						Ergebnis="Aktivierungscode falsch!"
					Else
						Credentials.Set(2, "aktiv")
						NutzerDatenbank.PutEncrypted(User, Credentials, Main.SchluesselBenutzerDatenbank)
						Ergebnis="EIS-Konto erfolgreich aktiviert!"
					End If
				Else
					Ergebnis="EIS-Konto wurde nicht aktiviert!"
				End If
			Else	
				Ergebnis="Zugriff gewaehrt!"	
			End If
		End If
		'Log(Ergebnis)
		Return Ergebnis
	End If
End Sub

Public Sub CalcHash(Password As String, salt() As Byte) As String
	Dim md As MessageDigest
	Dim spassword() As Byte = md.GetMessageDigest(Password.GetBytes("UTF8"), "SHA-512")
	Dim pbAndSalt(spassword.Length + salt.Length) As Byte
	bc.ArrayCopy(spassword, 0, pbAndSalt, 0, spassword.Length)
	bc.ArrayCopy(salt, 0, pbAndSalt, spassword.Length, salt.Length)
	Return bc.StringFromBytes(md.GetMessageDigest(pbAndSalt, "SHA-512"), "UTF8")
End Sub

