﻿Type=Class
Version=4.01
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

'PasswortFilter ist eine Filter-Klasse. Jede Anfrage, die auf den EIS-Server eingeht, geht zunächst über diese Filter-Klasse,
'bevor sie an das Modul FileServer weitergeleitet wird.
'Innerhalb dieser Klasse wird Absender und Passwort innerhalb der NutzerDatenbank für den Serverzugang geprüft.
'Ist das Konto falsch, wird die Anfrage blockiert und nicht mehr an andere Module weitergeleitet.

Sub Class_Globals
	
End Sub

Public Sub Initialize
	
End Sub

'Bei der Rückgabe von True wird die Anfrage weitergeleitet'
Public Sub Filter(req As ServletRequest, resp As ServletResponse) As Boolean
	'Hier den InputStream auslesen, ansonsten werden die Parameter nicht nach hinten durchgereicht
	
	Dim In As InputStream = req.InputStream	
	
	Dim verzeichnis As String = req.GetParameter("verzeichnis")
	Dim dok As String =req.GetParameter("dok")
	Dim absender As String = req.GetParameter("absender")
	Dim passwort As String = req.GetParameter("passwort")
	Dim acode As String = req.GetParameter("acode")
	
	'Hier alle Zeichenketten prüfen, die einen Directory-Traversal-Angriff verurachen könnten. Die Paramter entweder alle oder nur die prüfen, die auch ein Verzeichnis oder eine Dateianlage verursachen können.
	'Der Angriff sollt in der Logdatei gespeichert werden!
	If verzeichnis.Contains("../") Or verzeichnis.Contains("„%2e%2e%2f") Or dok.Contains("../") Or dok.Contains("„%2e%2e%2f") Then 
		resp.Write("Unautorisierter Zugriff!")
		Return False
	End If
	
	Dim Ergebnis As String
	'Absender und Passwort werden mit der NutzerDatenbank abgeglichen'
	Ergebnis = NutzerDB.CheckCredentials(absender, passwort, acode)
	
	If Ergebnis <> "Zugriff gewaehrt!" Then
		If Ergebnis.Length=0 Then 
			Ergebnis="Unautorisierter Zugriff!"
		End If
		resp.Write(Ergebnis)
		If Ergebnis="Zugriff mit falschen Absendernamen oder Passwort erfolgt!" Or Ergebnis.Length=0 Then resp.SendError(403, "Unautorisierter Zugriff!")
		Return False
	Else
		Return True
	End If
End Sub
